[Haskell-cafe] Building/installing haskelldb and friends with ghc 6.10.1

Duncan Coutts duncan.coutts at worc.ox.ac.uk
Tue Dec 9 09:32:30 EST 2008

On Sat, 2008-12-06 at 23:32 +0100, Laurent Giroud wrote:
> Hi everyone,
> I have been trying to install haskelldb in the last few days and  
> encountered a number of hurdles which raised a few questions and for  
> which I'd appreciate some insight and advice. Note that I am posting  
> here because they are not specifically haskelldb related.
> I am using Cabal to install haskelldb, haskelldb-hsql, haskelldb-hsql- 
> mysql (and others) and discovered that the packages available on  
> hackage do not build properly with ghc 6.10.1. The typical error being  
> of the following kind:

I don't think the haskelldb-* packages have been updated for ghc-6.8.

> Other searches in haskell cafe lead me to people advising to use HDBC  
> instead, after which I contemplated suicide for a few seconds before  
> coming back to my senses and cabal-installing haskelldb-hdbc which  
> quickly led me to error messages of the exact same kind mentioned above.
> Strangely enough, hdbc 1.1.5 itself installs quite fine using Cabal,  
> however, haskell-hdbc insists on depending on version 1.0.1.

That's because the haskelldb-hdbc depends on exactly HDBC ==1.0.1


> I haven't been able so far to find what configuration file to modify in order  
> for it to try to build with the latest Cabalized version (I admit I  
> didn't search much).

If you want to update haskelldb-hdbc then just change the .cabal file to
adjust the version constraints on the HDBC package and fix any issues
arising from the update (eg api changes).

I'm sure the maintainers would appreciate your patches since they seem
not to have any time to do the updates themselves.

> Pursuing any further would seem to require to delve deeper in the  
> intricacies of the Cabal system and fix either HSQL or HaskellDB-HDBC.  
> Since I really want to use HaskellDB I'll probably try these avenues,  
> but I would appreciate comments at this point from persons  
> knowledgeable in the evocated areas:
> Are the databases interface for haskelldb still officially maintained  
> and where is this information available ?

I would guess not. The .cabal file lists
haskelldb-users at lists.sourceforge.net as the maintainer. You might check
the archives for signs of activity or send an email there.

> Is the information that this and that package are compatible (or not)  
> with ghc 6.8.x or 6.10.1 available somewhere without compiling first  
> hand the packages ?

Yes. On the package page it lists build failures for ghc-6.8 and 6.10

> It would be immensely valuable to the haskell newcomer to have the
> incompatible packages signaled on
> http://hackage.haskell.org/packages/archive/pkg-list.html 
>   for example.

I hope we can do that in future. At the moment the build results are not
sufficiently reliable to advertise them that prominently. It's also
complicated by the fact that packages may build on some platforms and
not others.

> What would you recommend at this point : fix hsql, or haskelldb-hdbc  
> so it uses 1.1.5 instead of 1.1, try an alternative to haskelldb (are  
> there any ?) ?

If you need the high level api provided by haskelldb then yes fix it. If
not then just use HDBC directly.


More information about the Haskell-Cafe mailing list